## openjdk-9 9~b161

=== test/testlibrary/ctw/Makefile ===
#
# Copyright (c) 2013, 2016. Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#
#

ifneq "x$(ALT_BOOTDIR)" "x"
	BOOTDIR := $(ALT_BOOTDIR)
endif

ifeq "x$(BOOTDIR)" "x"
	JDK_HOME := $(shell dirname $(shell which java))/..
else
	JDK_HOME := $(BOOTDIR)
endif

SRC_DIR = src
BUILD_DIR = build
OUTPUT_DIR = $(BUILD_DIR)/classes
TESTLIBRARY_DIR = ../../../../test/lib

JAVAC = $(JDK_HOME)/bin/javac
JAR = $(JDK_HOME)/bin/jar

SRC_FILES = $(shell find $(SRC_DIR) $(TESTLIBRARY_DIR)/jdk/test/lib -name '*.java')
WB_SRC_FILES = $(shell find $(TESTLIBRARY_DIR)/sun/hotspot -name '*.java')

MAIN_CLASS = sun.hotspot.tools.ctw.CompileTheWorld

.PHONY: clean cleantmp

all: ctw.jar cleantmp

clean: cleantmp
	@rm -rf ctw.jar wb.jar

cleantmp:
	@rm -rf filelist wb_filelist manifest.mf
	@rm -rf $(BUILD_DIR)

ctw.jar: filelist wb.jar
	@mkdir -p $(OUTPUT_DIR)
	$(JAVAC) --add-exports java.base/jdk.internal.jimage=ALL-UNNAMED \
		 --add-exports java.base/jdk.internal.misc=ALL-UNNAMED \
		 --add-exports java.base/jdk.internal.reflect=ALL-UNNAMED \
		 -sourcepath $(SRC_DIR) -d $(OUTPUT_DIR) -cp wb.jar @filelist
	$(JAR) --create --file=$@ --main-class $(MAIN_CLASS) -C $(OUTPUT_DIR) .

wb.jar: wb_filelist
	@mkdir -p $(OUTPUT_DIR)
	$(JAVAC)  -sourcepath $(TESTLIBRARY_DIR) \
		-d $(OUTPUT_DIR) \
		-cp $(OUTPUT_DIR) \
		@wb_filelist
	$(JAR) --create --file=$@ -C $(OUTPUT_DIR) .

wb_filelist: $(WB_SRC_FILES)
	@rm -f $@
	@echo $(WB_SRC_FILES) > $@

filelist: $(SRC_FILES)
	@rm -f $@
	@echo $(SRC_FILES) > $@

=== debian/changelog ===
openjdk-9 (9~b161-1) unstable; urgency=medium

  * OpenJDK 9, b161.
  * Don't build the zero JRE on Ubuntu/s390x.
  * Fix changelog format.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 17 Mar 2017 00:09:34 +0100

openjdk-9 (9~b159-1) unstable; urgency=medium

  * OpenJDK 9, b159.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Mar 2017 19:03:10 +0100

openjdk-9 (9~b158-1) unstable; urgency=medium

  * OpenJDK 9, b158.
  * Add OpenJDK Stack Unwinder and Frame Decorator for gdb.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 26 Feb 2017 18:57:42 +0100

openjdk-9 (9~b155-1) unstable; urgency=medium

  * OpenJDK 9, b155.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Feb 2017 07:56:11 +0100

openjdk-9 (9~b154-1) unstable; urgency=medium

  * OpenJDK 9, b154.
  * Fix libjpeg dependency. Closes: #852420.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Jan 2017 23:33:55 +0100

openjdk-9 (9~b153-2) unstable; urgency=medium

  * Lower cpu requirements for Debian/s390x.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 21 Jan 2017 21:52:52 +0100

openjdk-9 (9~b153-1) unstable; urgency=medium

  * OpenJDK 9, b153.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 20 Jan 2017 14:39:18 +0100

openjdk-9 (9~b151-2) unstable; urgency=medium

  * Fix builds with zero and jamvm as an alternate VM.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 10 Jan 2017 15:40:20 +0100

openjdk-9 (9~b151-1) experimental; urgency=medium

  * OpenJDK 9, b151.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 08 Jan 2017 23:16:21 +0100

openjdk-9 (9~b149-1) experimental; urgency=medium

  * OpenJDK 9, b149.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 17 Dec 2016 10:58:22 +0100

openjdk-9 (9~b148-1) experimental; urgency=medium

  * OpenJDK 9, b148.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 12 Dec 2016 14:04:02 +0000

openjdk-9 (9~b147-1) experimental; urgency=medium

  * OpenJDK 9, b147.
  * Use sigset_t to store the signals used by the JVM (James Cowgill).
    Addresses: #841173.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 03 Dec 2016 15:41:51 +0100

openjdk-9 (9~b144-1) experimental; urgency=medium

  * OpenJDK 9, b144.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 11 Nov 2016 14:43:48 +0100

openjdk-9 (9~b143-2) experimental; urgency=medium

  * Fix 8168567, unbreaking the build on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 07 Nov 2016 15:46:43 +0100

openjdk-9 (9~b143-1) experimental; urgency=medium

  * OpenJDK 9, b143.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 Nov 2016 22:36:28 +0100

openjdk-9 (9~b142-1) experimental; urgency=medium

  * OpenJDK 9, b142.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 29 Oct 2016 12:03:19 +0200

openjdk-9 (9~b140-2) experimental; urgency=medium

  * Don't build zero on ppc64 and ppc64el (fails to build).

 -- Matthias Klose <doko@ubuntu.com>  Wed, 19 Oct 2016 17:02:37 +0200

openjdk-9 (9~b140-1) experimental; urgency=medium

  * OpenJDK 9, b140.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 17 Oct 2016 12:01:47 +0200

openjdk-9 (9~b139-1) experimental; urgency=medium

  * OpenJDK 9, b139.
  * Stop building zero on amd64, fails to build with hardening defaults.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 09 Oct 2016 10:03:18 +0200

openjdk-9 (9~b136-1ubuntu1) yakkety; urgency=medium

  * 8165323: (fs) Files.getFileStore fails with "Mount point not found" in
    chroot environment

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 Sep 2016 16:20:45 +0200

openjdk-9 (9~b136-1) experimental; urgency=medium

  * OpenJDK 9, b136.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 19 Sep 2016 20:33:07 +0200

openjdk-9 (9~b135-1) experimental; urgency=medium

  * OpenJDK 9, b135.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 10 Sep 2016 03:56:51 +0200

=== debian/control ===
Source: openjdk-9
Section: java
Priority: optional
Maintainer: OpenJDK Team <openjdk@lists.launchpad.net>
Uploaders: Matthias Klose <doko@ubuntu.com>
Build-Depends: debhelper (>= 9.20141010), dpkg-dev (>= 1.17.14),
  quilt, m4, lsb-release, zip, unzip,
  sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
  autoconf, automake, autotools-dev, ant, ant-optional, 
  g++-6,
  openjdk-8-jdk (>= 8u91-b14-2) [s390x], openjdk-8-jdk | openjdk-9-jdk,
  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libgtk2.0-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libgtk-3-dev, libelf-dev,
  libffi-dev, 
  zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev,  
  libnss3-dev (>= 2:3.17.1),
  mauve, jtreg (>= 4.2-b03-1~), xvfb, xauth, xfonts-base, libgl1-mesa-dri [!x32], twm | metacity, twm | dbus-x11, x11-xkb-utils,
  time, openjdk-8-jdk-headless <cross>,
Standards-Version: 3.9.8
Homepage: http://openjdk.java.net/
Vcs-Bzr: http://bazaar.launchpad.net/~openjdk/openjdk/openjdk9
Vcs-Browser: https://code.launchpad.net/~openjdk/openjdk/openjdk9

Package: openjdk-9-jdk-headless
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k sh4 sparc sparc64 s390x x32 kfreebsd-i386 kfreebsd-amd64
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-9-jre-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Suggests: openjdk-9-demo, openjdk-9-source
Provides: java-sdk-headless, java2-sdk-headless,
  java5-sdk-headless, java6-sdk-headless,
  java7-sdk-headless, java8-sdk-headless,
  java9-sdk-headless, java-compiler
Replaces: openjdk-9-jdk (<< 9~b107-0~),
Description: OpenJDK Development Kit (JDK) (headless)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-9-jre-headless
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k sh4 sparc sparc64 s390x x32 kfreebsd-i386 kfreebsd-amd64
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}, ${multiarch:Depends}
Depends: ${jredefault:Depends}, ${cacert:Depends},
  ${jcommon:Depends}, ${dlopenhl:Depends},
  ${mountpoint:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenhl:Recommends}, ${jamvm:Recommends}
Suggests: ${cacao:Recommends}, ${jamvm:Suggests},
  libnss-mdns,
  fonts-dejavu-extra,
  fonts-ipafont-gothic, fonts-ipafont-mincho, ttf-wqy-microhei | ttf-wqy-zenhei, fonts-indic,
Provides: java-runtime-headless, java2-runtime-headless,
  java5-runtime-headless, java6-runtime-headless,
  java7-runtime-headless, java8-runtime-headless,
  java9-runtime-headless,
  ${defaultvm:Provides}, ${jvm:Provides}
Breaks: oracle-java9-installer
Description: OpenJDK Java runtime, using ${vm:Name} (headless)
 Minimal Java runtime - needed for executing non GUI Java programs,
 using ${vm:Name}.

Package: openjdk-9-jdk
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k sh4 sparc sparc64 s390x x32 kfreebsd-i386 kfreebsd-amd64
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-9-jre (= ${binary:Version}),
  openjdk-9-jdk-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libxt-dev
Suggests: openjdk-9-demo, openjdk-9-source, visualvm
Provides: java-sdk, java2-sdk, java5-sdk, java6-sdk,
  java7-sdk, java8-sdk, java-compiler
Replaces: openjdk-9-jdk-headless (<< 9~b115-3)
Description: OpenJDK Development Kit (JDK)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-9-jre
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k sh4 sparc sparc64 s390x x32 kfreebsd-i386 kfreebsd-amd64
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-9-jre-headless (= ${binary:Version}),
  ${xandsound:Depends},
  ${dlopenjre:Depends}, ${dep:bridge},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenjre:Recommends}, fonts-dejavu-extra
Suggests: icedtea-8-plugin, ${pkg:pulseaudio}
Replaces: openjdk-9-jre-headless (<< 8u20~b20-3)
Provides: java-runtime, java2-runtime,
  java5-runtime, java6-runtime,
  java7-runtime, java8-runtime,
  java9-runtime,
Description: OpenJDK Java runtime, using ${vm:Name}
 Full Java runtime environment - needed for executing Java GUI and Webstart
 programs, using ${vm:Name}.

Package: openjdk-9-demo
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k sh4 sparc sparc64 s390x x32 kfreebsd-i386 kfreebsd-amd64
Priority: extra
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-9-jre (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Description: Java runtime based on OpenJDK (demos and examples)
 OpenJDK Java runtime

Package: openjdk-9-source
Architecture: all
Priority: extra
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-9-jre (>= ${source:Version}),
  openjdk-9-jdk (>= ${binary:Version}),
  ${misc:Depends}
Replaces: openjdk-8-jdk (<< 8u20~b26-1~)
Description: OpenJDK Development Kit (JDK) source files
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the Java programming language source files
 (src.zip) for all classes that make up the Java core API.

Package: openjdk-9-doc
Section: doc
Pre-Depends: ${dpkg:Depends}
Architecture: all
Priority: extra
Depends: ${misc:Depends}
Suggests: openjdk-9-jdk
Description: OpenJDK Development Kit (JDK) documentation
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the API documentation.

Package: openjdk-9-dbg
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k sh4 sparc sparc64 s390x x32 kfreebsd-i386 kfreebsd-amd64
Multi-Arch: same
Priority: extra
Section: debug
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-9-jre-headless (= ${binary:Version}),
   ${misc:Depends}
Recommends: openjdk-9-jre (= ${binary:Version})
Suggests: openjdk-9-jdk (= ${binary:Version})
Description: Java runtime based on OpenJDK (debugging symbols)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the debugging symbols.

Package: openjdk-9-jre-zero
Architecture: i386 ppc64 sparc64 kfreebsd-amd64 kfreebsd-i386
Multi-Arch: same
Priority: extra
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-9-jre-headless (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: ${zerovm:Provides}
Description: Alternative JVM for OpenJDK, using Zero/Shark
 The package provides an alternative runtime using the Zero VM and the 
 Shark Just In Time Compiler (JIT).  Built on architectures in addition
 to the Hotspot VM as a debugging aid for those architectures which don't
 have a Hotspot VM.
 .
 The VM is started with the option `-zero'. See the README.Debian for details.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

unexport LANG LC_ALL

dh_version := $(shell dpkg-query -f '$${Version}\n' -W debhelper | sed -n 's/^\(.\).*/\1/p')

# using brace expansion and substring replacements (${var:0:2}).
SHELL = /bin/bash

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_HOST_ARCH_CPU	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_CPU)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

PATH := $(CURDIR)/bin:$(PATH)
export PATH

CHANGELOG_VARS := $(shell dpkg-parsechangelog | sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

distribution := $(shell lsb_release --id --short)
distrel := $(shell lsb_release --codename --short)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)
ifeq ($(distrel),n/a)
  distrel := sid
endif

multiarch_dir = /$(DEB_HOST_MULTIARCH)

hotspot_archs	= amd64 i386 arm64 armel armhf ppc64 ppc64el sparc64 s390x kfreebsd-amd64 kfreebsd-i386
# FIXME: use bootcycle builds for zero archs?
bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), amd64 i386),yes)
zbootcycle_build =
ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
  bootcycle_build =
  zbootcycle_build =
endif

shark_archs	= amd64 i386 kfreebsd-amd64 kfreebsd-i386
# Shark build but just crash
shark_archs	=

ifneq (,$(filter $(distrel),lucid precise quantal raring saucy trusty utopic vivid wily lenny etch squeeze wheezy jessie))
  is_default = no
else
  is_default = yes
endif

srcdir		= src
builddir	= build
zbuilddir	= build-zero
jbuilddir	= build-jamvm

VENDOR		= openjdk
Vendor		= OpenJDK
TOP		= usr/lib/jvm
origin		= openjdk
basename	= openjdk-$(shortver)
ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
  priority	= $(if $(filter yes, $(is_default)),1091,1079)
  vm_name	= Hotspot JIT
else ifneq (,$(filter $(DEB_HOST_ARCH), $(shark_archs)))
  priority	= $(if $(filter yes, $(is_default)),1085,1075)
  vm_name	= Hotspot Shark
else
  priority	= $(if $(filter yes, $(is_default)),1084,1073)
  vm_name	= Hotspot Zero
endif
jvmver		= 1.9.0
shortver	= 9
updatever	:= $(shell echo $(PKGVERSION) | sed -n 's/^$(shortver)u\([0-9]\+\).*/\1/p')
buildver	:= $(shell echo $(PKGVERSION) | sed -n 's/^$(shortver)[^-]*-\(b[0-9]\+\).*/\1/p')

ifneq (,$(DEB_HOST_MULTIARCH))
  jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
  jdiralias	= java-$(jvmver)-$(origin)-$(DEB_HOST_ARCH)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)-common
  commonbasedir	= $(basedir)
  etcdir	= etc/java-$(shortver)-$(origin)
else
  jdirname	= java-$(shortver)-$(origin)
  jdiralias	= java-$(jvmver)-$(origin)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)
  etcdir	= etc/$(jdirname)
endif
security	= $(etcdir)/security
ifeq ($(bootcycle_build),yes)
  jreimg	= bootcycle-build/images/jre
  sdkimg	= bootcycle-build/images/jdk
  build_target	= bootcycle-images
else
  jreimg	= images/jre
  sdkimg	= images/jdk
  build_target	= images
endif
ifeq ($(zbootcycle_build),yes)
  zjreimg	= bootcycle-build/images/jre
  zsdkimg	= bootcycle-build/images/jdk
  zbuild_target	= bootcycle-images
else
  zjreimg	= images/jre
  zsdkimg	= images/jdk
  zbuild_target	= images
endif

# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
COMMA=,
SPACE = $(EMPTY) $(EMPTY)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(DEB_HOST_ARCH), armel))
  #with_check = disabled running check on $(DEB_HOST_ARCH)
endif
#with_check = disabled for this upload

with_docs = $(if $(findstring nodocs, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(findstring shark, $(PKGSOURCE)))
  with_docs = disabled for shark
endif

with_wgy_zenhai = $(if $(filter $(distrel),lenny),,yes)

arch_map	:= alpha=alpha arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc powerpcspe=ppc ppc64=ppc64 ppc64el=ppc64le sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32

jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
ifeq ($(DEB_HOST_ARCH),x32)
  jvmarch := x32
endif

default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)

any_archs = alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k sh4 sparc sparc64 s390x x32 kfreebsd-i386 kfreebsd-amd64

ifeq (,$(filter $(distrel),squeeze lucid))
  jamvm_archs = amd64 armel armhf i386 mips mipsel powerpc kfreebsd-i386 kfreebsd-amd64
endif
jamvm_archs =

ifeq (,$(filter $(distrel),wheezy squeeze lucid))
  jamvm_defaults =
endif

altshark_archs = powerpc ppc64 ppc64el
# Shark build but just crash
altshark_archs =

altzero_archs = $(filter-out amd64 arm64 armel armhf ppc64el sparc, $(hotspot_archs)) $(altshark_archs)
ifeq ($(derivative),Ubuntu)
  altzero_archs := $(filter-out s390x, $(altzero_archs))
endif

ifeq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS))$(filter noaltshark, $(DEB_BUILD_OPTIONS)))
  ifneq (,$(filter $(DEB_HOST_ARCH), $(altzero_archs)))
    ifneq (,$(filter $(DEB_HOST_ARCH), $(shark_archs) $(altshark_archs)))
      alternate_vms += shark
      zero_dir = shark
    else
      alternate_vms += zero
      zero_dir = zero
    endif
  endif
endif
ifeq (,$(filter noaltjamvm, $(DEB_BUILD_OPTIONS)))
  ifneq (,$(filter $(DEB_HOST_ARCH), $(jamvm_archs)))
    alternate_vms += jamvm
  endif
endif

BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
			/usr/lib/jvm/java-8-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
			/usr/lib/jvm/java-7-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
			/usr/lib/jvm/java-7-openjdk/bin/javac \
		))))

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
  BUILDJDK_HOME = $(CURDIR)/$(builddir)/$(sdkimg)
else
  BUILDJDK_HOME = $(BOOTJDK_HOME)
endif

OPENJDK_VERSION = jdk$(shortver)u$(updatever)-$(buildver)

# for Hotspot: hotspot/make/linux/makefiles/vm.make
# Don't overwrite Hotspot opt level :
# -O3 is already default option for hotspot

# FIXME: ftbfs with -Werror=format-security
dpkg_buildflags_hs = \
	DEB_CFLAGS_MAINT_STRIP="-O2 -Werror=format-security" \
	DEB_CXXFLAGS_MAINT_STRIP="-O2 -Werror=format-security" \
	DEB_CFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations" \
	DEB_CXXFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations"
# jdk/make/CompileDemos.gmk (SetupJVMTIDemo) doesn't like commas in flags
dpkg_buildflags_hs += \
	DEB_LDFLAGS_MAINT_STRIP="-Wl,-z,relro -Wl,-Bsymbolic-functions" \
	DEB_LDFLAGS_MAINT_APPEND="-Xlinker -z -Xlinker relro -Xlinker -Bsymbolic-functions"
dpkg_buildflags_hs += dpkg-buildflags
export EXTRA_CPPFLAGS_HS := $(shell $(dpkg_buildflags_hs) --get CPPFLAGS)
export EXTRA_CFLAGS_HS   := $(shell $(dpkg_buildflags_hs) --get CFLAGS; $(dpkg_buildflags_hs) --get CPPFLAGS)
export EXTRA_CXXFLAGS_HS := $(shell $(dpkg_buildflags_hs) --get CXXFLAGS) -Wno-deprecated-declarations
export EXTRA_LDFLAGS_HS  := $(shell $(dpkg_buildflags_hs) --get LDFLAGS)

dpkg_buildflags_zero = \
	DEB_CFLAGS_MAINT_STRIP="-O2 -Werror=format-security -fstack-protector -fstack-protector-strong" \

## openjdk-9 9~b181

=== test/Makefile ===
#
# Copyright (c) 1995, 2016, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.  Oracle designates this
# particular file as subject to the "Classpath" exception as provided
# by Oracle in the LICENSE file that accompanied this code.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#
#

NATIVE_TEST_PATH := hotspot/jtreg/native

TREAT_EXIT_CODE_1_AS_0 := true

CLEAN_BEFORE_PREP := true

USE_JTREG_VERSION := 4.1

USE_JTREG_ASSERT := false

LIMIT_JTREG_VM_MEMORY := false

IGNORE_MARKED_TESTS := true

# Get OS name from uname (Cygwin inexplicably adds _NT-5.1)
UNAME_S := $(shell uname -s | cut -f1 -d_)

ifeq ($(UNAME_S), SunOS)
  NUM_CORES := $(shell LC_MESSAGES=C /usr/sbin/psrinfo -v | grep -c on-line)
endif
ifeq ($(UNAME_S), Linux)
  NUM_CORES := $(shell cat /proc/cpuinfo  | grep -c processor)
endif
ifeq ($(UNAME_S), Darwin)
  NUM_CORES := $(shell /usr/sbin/sysctl -n hw.ncpu)
endif
ifeq ($(findstring CYGWIN,$(UNAME_S)), CYGWIN)
  ifneq ($(NUMBER_OF_PROCESSORS), )
    NUM_CORES := $(NUMBER_OF_PROCESSORS)
  else
    ifneq ($(HOTSPOT_BUILD_JOBS), )
      NUM_CORES := $(HOTSPOT_BUILD_JOBS)
    else
      NUM_CORES := 1 # fallback
    endif
  endif
endif

# Concurrency based on min(cores / 2, 12)
CONCURRENCY := $(shell expr $(NUM_CORES) / 2)
ifeq ($(CONCURRENCY), 0)
  CONCURRENCY := 1
else ifeq ($(shell expr $(CONCURRENCY) \> 12), 1)
  CONCURRENCY := 12
endif

# Make sure MaxRAMFraction is high enough to not cause OOM or swapping since we may end up with a lot of JVM's
JTREG_BASIC_OPTIONS += -vmoption:-XX:MaxRAMFraction=$(shell expr $(CONCURRENCY) \* 4)

# Include the common base file with most of the logic
include ../../test/TestCommon.gmk

################################################################
# Default make rule (runs jtreg_tests)
all: hotspot_all
	@$(ECHO) "Testing completed successfully"

# Support "hotspot_" prefixed test make targets (too)
# The hotspot_% targets are used by the top level Makefile
# Unless explicitly defined below, hotspot_<x> is interpreted as a jtreg test group name
hotspot_%:
	$(ECHO) "Running tests: $@"
	$(MAKE) -j 1 TEST_SELECTION=":$@" UNIQUE_DIR=$@ jtreg_tests;

hotspot_internal:
	$(ALT_OUTPUTDIR)/jdk/bin/java -XX:+ExecuteInternalVMTests -XX:+ShowMessageBoxOnError -version

################################################################
ALT_MAKE ?= closed
-include $(ALT_MAKE)/Makefile

# flags used to execute java in test targets
TEST_FLAGS += -version -Xinternalversion -X -help

sanitytest: prep $(PRODUCT_HOME)
	@for flag in $(TEST_FLAGS);                                             \
	do                                                                      \
	    echo Executing java $(JAVA_OPTIONS) $$flag;                         \
	    $(PRODUCT_HOME)/bin/java $(JAVA_OPTIONS) $$flag;                    \
	    res=$$?;                                                            \
	    if [ $$res -ne 0 ]; then                                            \
	        exit $$res;                                                     \
	    fi;                                                                 \
	done

PHONY_LIST += sanitytest

################################################################

# basicvmtest (make sure various basic java options work)

# Set up the directory in which the jvm directories live (client/, server/, etc.)
ifeq ($(PLATFORM),windows)
JVMS_DIR := $(PRODUCT_HOME)/bin
else
JVMS_DIR := $(PRODUCT_HOME)/lib
endif

# Use the existance of a directory as a sign that jvm variant is available
CANDIDATE_JVM_VARIANTS := client minimal server
JVM_VARIANTS := $(strip $(foreach x,$(CANDIDATE_JVM_VARIANTS),$(if $(wildcard $(JVMS_DIR)/$(x)),$(x))))

hotspot_basicvmtest:
	for variant in $(JVM_VARIANTS);                                           \
	do                                                                        \
	    $(MAKE) JAVA_ARGS="$(JAVA_ARGS) -$$variant" hotspot_$${variant}test;  \
	    res=$$?;                                                              \
	    if [ $$res -ne 0 ]; then                                              \
	        exit $$res;                                                       \
	    fi;                                                                   \
	done

PHONY_LIST += hotspot_basicvmtest

################################################################

# clienttest (make sure various basic java client options work)

hotspot_clienttest clienttest: sanitytest
	$(RM) $(PRODUCT_HOME)/jre/lib/*/client/classes.jsa
	$(RM) $(PRODUCT_HOME)/jre/bin/client/classes.jsa
	$(PRODUCT_HOME)/bin/java $(JAVA_OPTIONS) -Xshare:dump

PHONY_LIST += hotspot_clienttest clienttest

################################################################

# minimaltest (make sure various basic java minimal options work)

hotspot_minimaltest minimaltest: sanitytest

PHONY_LIST += hotspot_minimaltest minimaltest

################################################################

# servertest (make sure various basic java server options work)

hotspot_servertest servertest: sanitytest

PHONY_LIST += hotspot_servertest servertest

################################################################

# Run the native gtest tests from the test image

define NEWLINE


endef


hotspot_gtest:
	$(foreach v, $(JVM_VARIANTS), \
	  $(MAKE) hotspot_gtest$v $(NEWLINE) )

hotspot_gtestserver hotspot_gtestclient hotspot_gtestminimal: hotspot_gtest%:
	$(TESTNATIVE_DIR)/hotspot/gtest/$*/gtestLauncher \
	    -jdk $(shell $(GETMIXEDPATH) "$(PRODUCT_HOME)")

PHONY_LIST += hotspot_gtest hotspot_gtestserver hotspot_gtestclient \
    hotspot_gtestminimal

=== debian/changelog ===
openjdk-9 (9~b181-4) unstable; urgency=medium

  * Fix whitespace in debian/rules. Closes: #873104, 873117.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 24 Aug 2017 19:15:14 +0200

openjdk-9 (9~b181-3) unstable; urgency=medium

  * Fix libjvm.so's .debug file names.
  * Install an apport hook when building on Ubuntu and derivatives.
  * Update the disable-doclint patch (Chris West). Closes: #866908.
  * Configure --with-debug-level=release on m68k as well (Adrian Glaubitz).
    Closes: #871316.
  * Drop armel and sparc from the list of alternative zero archs (Adrian
    Glaubitz). Closes: #871319.
  * Simplify the zero-sparc patch (Adrian Glaubitz). Closes: #872756.
  * Remove some obsolete unused patches. Closes: #871606.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 24 Aug 2017 00:42:22 +0200

openjdk-9 (9~b181-2) unstable; urgency=medium

  * Update the jdk-8067331 patch (Adrian Glaubitz). Closes: #871009.
  * Build zero on armhf again.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 07 Aug 2017 10:28:46 -0400

openjdk-9 (9~b181-1) unstable; urgency=medium

  * OpenJDK 9, b181.
  * Don't hard-code multiarch-support dependency. Closes: #870521.
  * Just configure m68k --with-debug-level=slowdebug. Closes: #868255.
  * Fix atomic_copy64 on powerpc (Andrew Haley). Closes: #870403.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 04 Aug 2017 07:35:49 -0400

openjdk-9 (9~b179-2) unstable; urgency=medium

  * Really configure --with-debug-level=slowdebug on Zero-only architectures.
    Closes: #868255.
  * Really enable the zero-sparc patch (Adrian Glaubitz). Closes: #864359.
  * Try again building zero on arm64 with slowdebug.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jul 2017 13:20:10 +0200

openjdk-9 (9~b179-1) unstable; urgency=medium

  * OpenJDK 9, b179.
  * Drop armel as a hotspot architecture. Closes: #864464.
  * Configure --with-debug-level=slowdebug on Zero-only architectures.
    Closes: #868255.
  * Fix recommendation of microhei/zenhei font packages. Closes: #868205.
  * Enable the zero-sparc patch (Adrian Glaubitz). Closes: #864359.
  * Update the disable-doclint patch (Chris West). Closes: #866908.
  * Disable the jamvm autopkg tests.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 22 Jul 2017 11:49:18 +0200

openjdk-9 (9~b177-3) unstable; urgency=medium

  * Fix applying the s390x-thread-stack-size patch.

 -- Matthias Klose <doko@debian.org>  Fri, 07 Jul 2017 19:18:19 +0200

openjdk-9 (9~b177-2) unstable; urgency=medium

  * Try to build zero again on amd64, arm64, ppc64el and s390x.
  * Keep the conf/* symlinks in the JAVA_HOME directory.
    Closes: #866924, #863080.
  * Drop armel from the list of hotspot architectures. See #864464.
  * Stop using deprecated GNOME libraries. Closes: #850268.
  * Apply sparc64 build fixes (Adrian Glaubitz). Closes: #864351.
  * Update the zero-sparc patch (Adrian Glaubitz). Closes: #864359.
  * Update the m68k-support patch (Adrian Glaubitz). Closes: #864595.
  * Disable generation of jvmti.html on m68k (Adrian Glaubitz).
    Closes: #864596.
  * Update the zero-sh patch (Adrian Glaubitz). Closes: #864643.
  * Update the jdk-target-arch-define patch. Closes: #865129.
  * Provide jvmdir symlink in /usr/lib/debug. Addresses: #867314.
  * Fix pt_BR translation in awt message. Addresses: #863331.
  * Drop the 8073754-stack-overflow-9-build patch. Closes: #864288.
  * Use sigset_t to store the signals used by the JVM (James Cowgill).
    Closes: #841173.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 07 Jul 2017 12:28:53 +0200

openjdk-9 (9~b177-1) unstable; urgency=medium

  * OpenJDK 9, b177.

 -- Matthias Klose <doko@debian.org>  Fri, 07 Jul 2017 02:18:33 +0000

openjdk-9 (9~b170-2) unstable; urgency=medium

  * OpenJDK 9, b170.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 18 May 2017 11:57:43 -0700

openjdk-9 (9~b169-1) unstable; urgency=medium

  * OpenJDK 9, b169.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 14 May 2017 10:11:24 -0700

openjdk-9 (9~b168-1) unstable; urgency=medium

  * OpenJDK 9, b168.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 05 May 2017 14:33:09 +0200

openjdk-9 (9~b164-1) unstable; urgency=medium

  * OpenJDK 9, b164.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Apr 2017 21:39:41 +0200

=== debian/control ===
--- 
+++ 
@@ -39,7 +39,7 @@
 Package: openjdk-9-jre-headless
 Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k sh4 sparc sparc64 s390x x32 kfreebsd-i386 kfreebsd-amd64
 Multi-Arch: same
-Pre-Depends: ${dpkg:Depends}, ${multiarch:Depends}
+Pre-Depends: ${dpkg:Depends}
 Depends: ${jredefault:Depends}, ${cacert:Depends},
   ${jcommon:Depends}, ${dlopenhl:Depends},
   ${mountpoint:Depends},
@@ -148,7 +148,7 @@
  This package contains the debugging symbols.
 
 Package: openjdk-9-jre-zero
-Architecture: i386 ppc64 sparc64 kfreebsd-amd64 kfreebsd-i386
+Architecture: amd64 i386 arm64 armhf ppc64 ppc64el sparc64 s390x kfreebsd-amd64 kfreebsd-i386 
 Multi-Arch: same
 Priority: extra
 Pre-Depends: ${dpkg:Depends}

=== debian/rules ===
--- 
+++ 
@@ -39,7 +39,7 @@
 
 multiarch_dir = /$(DEB_HOST_MULTIARCH)
 
-hotspot_archs	= amd64 i386 arm64 armel armhf ppc64 ppc64el sparc64 s390x kfreebsd-amd64 kfreebsd-i386
+hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el sparc64 s390x kfreebsd-amd64 kfreebsd-i386
 # FIXME: use bootcycle builds for zero archs?
 bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
 bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), amd64 i386),yes)
@@ -163,10 +163,7 @@
 # Shark build but just crash
 altshark_archs =
 
-altzero_archs = $(filter-out amd64 arm64 armel armhf ppc64el sparc, $(hotspot_archs)) $(altshark_archs)
-ifeq ($(derivative),Ubuntu)
-  altzero_archs := $(filter-out s390x, $(altzero_archs))
-endif
+# altzero_archs = $(filter-out , $(hotspot_archs)) $(altshark_archs)
 
 ifeq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS))$(filter noaltshark, $(DEB_BUILD_OPTIONS)))
   ifneq (,$(filter $(DEB_HOST_ARCH), $(altzero_archs)))
@@ -221,3 +218,5 @@
 
 dpkg_buildflags_zero = \
 	DEB_CFLAGS_MAINT_STRIP="-O2 -Werror=format-security -fstack-protector -fstack-protector-strong" \
+	DEB_CXXFLAGS_MAINT_STRIP="-O2 -Werror=format-security -fstack-protector -fstack-protector-strong" \
+	DEB_CFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations" \

## openjdk-9 9.0.1+11

=== debian/changelog ===
openjdk-9 (9.0.1+11-1mx15+1) mx; urgency=medium

  * Rebuild for MX 15.
  * Add MX 15/16 distrel names alongside Jessie.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 30 Oct 2017 16:07:00 -0700

openjdk-9 (9.0.1+11-1) unstable; urgency=medium

  * OpenJDK 9.0.1+11 release.
  * Bump standards version.
  * Configure with an empty --with-version-pre setting. LP: #1722410.
  * Remove JamVM packaging bits. Closes: #877523.
  * Remove Shark packaging bits.
  * Fix java/javac/jar lockups on SMP Alpha (Michael Cree). Closes: #875288.
  * Fix crashes in i386 applications using JNI due to Hotspot workaround for
    Exec Shield (Ben Hutchings). Closes: #876069.
  * Re-enable building altzero architectures: Closes: #874292.
  * Update the zero-sparc patch (Adrian Glaubitz). Closes: #874265.
  * Fix recommendation of microhei/zenhei font packages. Closes: #868205.
  * Move jmod files into the openjdk-jdk-headless package. Closes: #878272.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 27 Oct 2017 01:44:31 +0200

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,23 @@
 Source: openjdk-9
 Section: java
 Priority: optional
-Maintainer: OpenJDK Team <openjdk@lists.launchpad.net>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+Bugs: mailto: <stevep@mxlinux.org>
+XSBC-Original-Maintainer: OpenJDK Team <openjdk@lists.launchpad.net>
 Uploaders: Matthias Klose <doko@ubuntu.com>
 Build-Depends: debhelper (>= 9.20141010), dpkg-dev (>= 1.17.14),
   quilt, m4, lsb-release, zip, unzip,
   sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
-  autoconf, automake, autotools-dev, ant, ant-optional, 
-  g++-6,
+  autoconf, automake, autotools-dev, ant, ant-optional,
+  g++-4.9,
   openjdk-8-jdk (>= 8u91-b14-2) [s390x], openjdk-8-jdk | openjdk-9-jdk,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libgtk2.0-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libgtk-3-dev, libelf-dev,
-  libffi-dev, 
+  libffi-dev,
   zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev,  
   libnss3-dev (>= 2:3.17.1),
   mauve, jtreg (>= 4.2-b03-1~), xvfb, xauth, xfonts-base, libgl1-mesa-dri [!x32], twm | metacity, twm | dbus-x11, x11-xkb-utils,
   time, openjdk-8-jdk-headless <cross>,
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Homepage: http://openjdk.java.net/
 Vcs-Bzr: http://bazaar.launchpad.net/~openjdk/openjdk/openjdk9
 Vcs-Browser: https://code.launchpad.net/~openjdk/openjdk/openjdk9
@@ -31,7 +33,9 @@
   java5-sdk-headless, java6-sdk-headless,
   java7-sdk-headless, java8-sdk-headless,
   java9-sdk-headless, java-compiler
+Breaks: openjdk-9-jre-headless (<< 9.0.1+11-1~)
 Replaces: openjdk-9-jdk (<< 9~b107-0~),
+  openjdk-9-jre-headless (<< 9.0.1+11-1~)
 Description: OpenJDK Development Kit (JDK) (headless)
  OpenJDK is a development environment for building applications,
  applets, and components using the Java programming language.
@@ -44,11 +48,10 @@
   ${jcommon:Depends}, ${dlopenhl:Depends},
   ${mountpoint:Depends},
   ${shlibs:Depends}, ${misc:Depends}
-Recommends: ${dlopenhl:Recommends}, ${jamvm:Recommends}
-Suggests: ${cacao:Recommends}, ${jamvm:Suggests},
-  libnss-mdns,
+Recommends: ${dlopenhl:Recommends}
+Suggests: libnss-mdns,
   fonts-dejavu-extra,
-  fonts-ipafont-gothic, fonts-ipafont-mincho, ttf-wqy-microhei | ttf-wqy-zenhei, fonts-indic,
+  fonts-ipafont-gothic, fonts-ipafont-mincho, fonts-wqy-microhei | fonts-wqy-zenhei, fonts-indic,
 Provides: java-runtime-headless, java2-runtime-headless,
   java5-runtime-headless, java6-runtime-headless,
   java7-runtime-headless, java8-runtime-headless,
@@ -96,7 +99,7 @@
 
 Package: openjdk-9-demo
 Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k sh4 sparc sparc64 s390x x32 kfreebsd-i386 kfreebsd-amd64
-Priority: extra
+Priority: optional
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-9-jre (= ${binary:Version}),
   ${shlibs:Depends}, ${misc:Depends}
@@ -105,7 +108,7 @@
 
 Package: openjdk-9-source
 Architecture: all
-Priority: extra
+Priority: optional
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-9-jre (>= ${source:Version}),
   openjdk-9-jdk (>= ${binary:Version}),
@@ -122,7 +125,7 @@
 Section: doc
 Pre-Depends: ${dpkg:Depends}
 Architecture: all
-Priority: extra
+Priority: optional
 Depends: ${misc:Depends}
 Suggests: openjdk-9-jdk
 Description: OpenJDK Development Kit (JDK) documentation
@@ -134,7 +137,7 @@
 Package: openjdk-9-dbg
 Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k sh4 sparc sparc64 s390x x32 kfreebsd-i386 kfreebsd-amd64
 Multi-Arch: same
-Priority: extra
+Priority: optional
 Section: debug
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-9-jre-headless (= ${binary:Version}),
@@ -148,16 +151,15 @@
  This package contains the debugging symbols.
 
 Package: openjdk-9-jre-zero
-Architecture: amd64 i386 arm64 armhf ppc64 ppc64el sparc64 s390x kfreebsd-amd64 kfreebsd-i386 
+Architecture: amd64 i386 arm64 armhf ppc64 ppc64el sparc64 s390x kfreebsd-amd64 kfreebsd-i386
 Multi-Arch: same
-Priority: extra
+Priority: optional
 Pre-Depends: ${dpkg:Depends}
 Depends: openjdk-9-jre-headless (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Provides: ${zerovm:Provides}
-Description: Alternative JVM for OpenJDK, using Zero/Shark
- The package provides an alternative runtime using the Zero VM and the 
- Shark Just In Time Compiler (JIT).  Built on architectures in addition
- to the Hotspot VM as a debugging aid for those architectures which don't
- have a Hotspot VM.
+Description: Alternative JVM for OpenJDK, using Zero
+ The package provides an alternative runtime using the Zero VM. Built on
+ architectures in addition to the Hotspot VM as a debugging aid for those
+ architectures which don't have a Hotspot VM.
  .
  The VM is started with the option `-zero'. See the README.Debian for details.

=== debian/rules ===
--- 
+++ 
@@ -34,7 +34,7 @@
                elif dpkg-vendor --derives-from Debian; then echo Debian; \
                else echo Unknown; fi)
 ifeq ($(distrel),n/a)
-  distrel := sid
+  distrel := jessie
 endif
 
 multiarch_dir = /$(DEB_HOST_MULTIARCH)
@@ -49,11 +49,7 @@
   zbootcycle_build =
 endif
 
-shark_archs	= amd64 i386 kfreebsd-amd64 kfreebsd-i386
-# Shark build but just crash
-shark_archs	=
-
-ifneq (,$(filter $(distrel),lucid precise quantal raring saucy trusty utopic vivid wily lenny etch squeeze wheezy jessie))
+ifneq (,$(filter $(distrel),lucid precise quantal raring saucy trusty utopic vivid wily lenny etch squeeze wheezy jessie Fusion Metamorphosis))
   is_default = no
 else
   is_default = yes
@@ -62,7 +58,6 @@
 srcdir		= src
 builddir	= build
 zbuilddir	= build-zero
-jbuilddir	= build-jamvm
 
 VENDOR		= openjdk
 Vendor		= OpenJDK
@@ -72,17 +67,21 @@
 ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
   priority	= $(if $(filter yes, $(is_default)),1091,1079)
   vm_name	= Hotspot JIT
-else ifneq (,$(filter $(DEB_HOST_ARCH), $(shark_archs)))
-  priority	= $(if $(filter yes, $(is_default)),1085,1075)
-  vm_name	= Hotspot Shark
 else
   priority	= $(if $(filter yes, $(is_default)),1084,1073)
   vm_name	= Hotspot Zero
 endif
 jvmver		= 1.9.0
 shortver	= 9
-updatever	:= $(shell echo $(PKGVERSION) | sed -n 's/^$(shortver)u\([0-9]\+\).*/\1/p')
-buildver	:= $(shell echo $(PKGVERSION) | sed -n 's/^$(shortver)[^-]*-\(b[0-9]\+\).*/\1/p')
+v_upstream	:= $(shell echo $(PKGVERSION) | sed 's/-[^-][^-]*$$//')
+v_pkgrel	:= $(shell echo $(PKGVERSION) | sed 's/^.*-//')
+v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
+v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
+# that should be the package version ...
+
+ifneq ($(PKGVERSION),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
+  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(PKGVERSION))
+endif
 
 ifneq (,$(DEB_HOST_MULTIARCH))
   jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
@@ -132,11 +131,8 @@
 #with_check = disabled for this upload
 
 with_docs = $(if $(findstring nodocs, $(DEB_BUILD_OPTIONS)),,yes)
-ifneq (,$(findstring shark, $(PKGSOURCE)))
-  with_docs = disabled for shark
-endif
-
-with_wgy_zenhai = $(if $(filter $(distrel),lenny),,yes)
+
+with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)
 
 arch_map	:= alpha=alpha arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc powerpcspe=ppc ppc64=ppc64 ppc64el=ppc64le sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32
 
@@ -150,35 +146,12 @@
 
 any_archs = alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el m68k sh4 sparc sparc64 s390x x32 kfreebsd-i386 kfreebsd-amd64
 
-ifeq (,$(filter $(distrel),squeeze lucid))
-  jamvm_archs = amd64 armel armhf i386 mips mipsel powerpc kfreebsd-i386 kfreebsd-amd64
-endif
-jamvm_archs =
-
-ifeq (,$(filter $(distrel),wheezy squeeze lucid))
-  jamvm_defaults =
-endif
-
-altshark_archs = powerpc ppc64 ppc64el
-# Shark build but just crash
-altshark_archs =
-
-# altzero_archs = $(filter-out , $(hotspot_archs)) $(altshark_archs)
-
-ifeq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS))$(filter noaltshark, $(DEB_BUILD_OPTIONS)))
+altzero_archs = $(hotspot_archs)
+
+ifeq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS)))
   ifneq (,$(filter $(DEB_HOST_ARCH), $(altzero_archs)))
-    ifneq (,$(filter $(DEB_HOST_ARCH), $(shark_archs) $(altshark_archs)))
-      alternate_vms += shark
-      zero_dir = shark
-    else
-      alternate_vms += zero
-      zero_dir = zero
-    endif
-  endif
-endif
-ifeq (,$(filter noaltjamvm, $(DEB_BUILD_OPTIONS)))
-  ifneq (,$(filter $(DEB_HOST_ARCH), $(jamvm_archs)))
-    alternate_vms += jamvm
+    alternate_vms += zero
+    zero_dir = zero
   endif
 endif
 
@@ -193,8 +166,6 @@
 else
   BUILDJDK_HOME = $(BOOTJDK_HOME)
 endif
-
-OPENJDK_VERSION = jdk$(shortver)u$(updatever)-$(buildver)
 
 # for Hotspot: hotspot/make/linux/makefiles/vm.make
 # Don't overwrite Hotspot opt level :
@@ -220,3 +191,16 @@
 	DEB_CFLAGS_MAINT_STRIP="-O2 -Werror=format-security -fstack-protector -fstack-protector-strong" \
 	DEB_CXXFLAGS_MAINT_STRIP="-O2 -Werror=format-security -fstack-protector -fstack-protector-strong" \
 	DEB_CFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations" \
+	DEB_CXXFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations"
+# jdk/make/CompileDemos.gmk (SetupJVMTIDemo) doesn't like commas in flags
+dpkg_buildflags_zero += \
+	DEB_LDFLAGS_MAINT_STRIP="-Wl,-z,relro -Wl,-Bsymbolic-functions" \
+	DEB_LDFLAGS_MAINT_APPEND="-Xlinker -z -Xlinker relro -Xlinker -Bsymbolic-functions"
+dpkg_buildflags_zero += dpkg-buildflags
+export EXTRA_CPPFLAGS_ZERO := $(shell $(dpkg_buildflags_zero) --get CPPFLAGS)
+export EXTRA_CFLAGS_ZERO   := $(shell $(dpkg_buildflags_zero) --get CFLAGS; $(dpkg_buildflags_zero) --get CPPFLAGS)
+export EXTRA_CXXFLAGS_ZERO := $(shell $(dpkg_buildflags_zero) --get CXXFLAGS)
+export EXTRA_LDFLAGS_ZERO  := $(shell $(dpkg_buildflags_zero) --get LDFLAGS)
+
+# for JDK: jdk/make/common/Defs.gmk
+# Don't overwrite JDK opt level :
